/*
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package org.ow2.petals.registry.core.repository.bo;

import javax.xml.namespace.QName;

/**
 * @author Christophe HAMERLING - eBM WebSourcing
 * @author Charles Casadei - eBM WebSourcing
 * 
 */
public class TOAdapter {

    public org.ow2.petals.registry.api.Resource toTO(final Endpoint boEndpoint) {
        if (boEndpoint == null) {
            return null;
        }

        final org.ow2.petals.registry.api.Resource result = new org.ow2.petals.registry.api.Resource();
        final org.ow2.petals.registry.api.Endpoint resourceEndpoint = new org.ow2.petals.registry.api.Endpoint();

        result.setCreationTime(boEndpoint.getCreationTime());
        result.setEndpoint(resourceEndpoint);

        final String path = boEndpoint.getPath();
        if (path != null) {
            result.setPath(path);
        }

        final String rootRegistry = boEndpoint.getRootRegistry();
        if (rootRegistry != null) {
            result.setRootRegistry(rootRegistry);
        }

        final String description = boEndpoint.getDescription();
        if (description != null) {
            resourceEndpoint.setDescription(description);
        }

        final String name = boEndpoint.getName();
        if (name != null) {
            resourceEndpoint.setName(QName.valueOf(name));
        }

        final String service = boEndpoint.getService();
        if (service != null) {
            resourceEndpoint.setService(QName.valueOf(service));
        }

        final String interfaceName = boEndpoint.getInterfaceName();
        if (interfaceName != null) {
            resourceEndpoint.setInterface(QName.valueOf(interfaceName));
        }

        final String component = boEndpoint.getComponent();
        if (component != null) {
            resourceEndpoint.setComponent(component);
        }

        final String container = boEndpoint.getContainer();
        if (container != null) {
            resourceEndpoint.setContainer(container);
        }

        final String subdomain = boEndpoint.getSubdomain();
        if (subdomain != null) {
            resourceEndpoint.setSubdomain(subdomain);
        }

        final String type = boEndpoint.getType();
        if (type != null) {
            resourceEndpoint.setType(type);
        }

        return result;
    }

    public Endpoint toBO(org.ow2.petals.registry.api.Resource resource) {

        final org.ow2.petals.registry.core.repository.bo.Endpoint result = new org.ow2.petals.registry.core.repository.bo.Endpoint();
        
        if (resource.getEndpoint() == null) {
            return null;
        }

        final org.ow2.petals.registry.api.Endpoint resourceEndpoint = resource.getEndpoint();

        result.setCreationTime(resource.getCreationTime());
        result.setPath(resource.getPath());
        result.setRootRegistry(resource.getRootRegistry());

        final String name = resourceEndpoint.getName();
        if (name != null) {
            result.setName(name);
        }

        final QName service = resourceEndpoint.getService();
        if (service != null) {
            result.setService(service.toString());
        }

        final QName interfaceName = resourceEndpoint.getInterface();
        if (interfaceName != null) {
            result.setInterfaceName(interfaceName.toString());
        }

        final String component = resourceEndpoint.getComponent();
        if (component != null) {
            result.setComponent(component);
        }

        final String container = resourceEndpoint.getContainer();
        if (container != null) {
            result.setContainer(container);
        }

        final String subdomain = resourceEndpoint.getSubdomain();
        if (subdomain != null) {
            result.setSubdomain(subdomain);
        }

        final String type = resourceEndpoint.getType();
        if (type != null) {
            result.setType(type);
        }

        final String description = resourceEndpoint.getDescription();
        if (description != null) {
            result.setDescription(description);
        }

        return result;
    }
}
