/*
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package org.ow2.petals.registry.core.ws.adapters;

import org.ow2.petals.registry.api.Resource;
import org.ow2.petals.registry.api.ws.adapters.ResourceAdapter;

/**
 * @author Christophe HAMERLING - eBM WebSourcing
 * 
 */
public class ResourceAdapterImpl implements ResourceAdapter {

    public ResourceAdapterImpl() {
    }

    public org.ow2.petals.registry.api.ws.to.Resource toWSResource(Resource resource) {
        org.ow2.petals.registry.api.ws.to.Resource result = new org.ow2.petals.registry.api.ws.to.Resource();
        result.setCreationTime(resource.getCreationTime());
        result.setEndpoint(AdaptersManager.getEndpointAdapter()
                .toWSEndpoint(resource.getEndpoint()));
        result.setRevision(resource.getRevision());
        result.setProperties(resource.getProperties());
        result.setRootRegistry(resource.getRootRegistry());
        result.setPath(resource.getPath());
        return result;
    }

    public Resource toRegistryResource(org.ow2.petals.registry.api.ws.to.Resource resource) {
        Resource result = new Resource();
        result.setCreationTime(resource.getCreationTime());
        result.setEndpoint(AdaptersManager.getEndpointAdapter().toRegistryEndpoint(resource.getEndpoint()));
        result.setProperties(resource.getProperties());
        result.setRevision(resource.getRevision());
        result.setRootRegistry(resource.getRootRegistry());
        result.setPath(resource.getPath());
        return result;
    }

}
